#include <stdio.h>
#include "pico/stdlib.h"
#include "Temps.h"

uint32_t temps_ms=0;
bool temps_est_init=false;
struct repeating_timer timer;

/// @brief Fonction qui incrément notre temps_ms de 1, appelé par interruption toutes les 1 ms.
/// @param t : necessaire uniquement à cause du SDK du RPi Pico.
bool Temps_increment(struct repeating_timer *t){
    temps_ms++;
    return true;
}

/// @brief Crée l'interruption qui appellera la fonction Temps_increment toutes les 1 ms.
void Temps_init(void){
    if(!temps_est_init){
        temps_ms=0;
        add_repeating_timer_ms(-1, Temps_increment, NULL, &timer);
        temps_est_init = true;
    }
}

/// @brief Renvoie le temps actuel, depuis l'appel de Temps_init, en millisecondes
uint32_t Temps_get_temps_ms(void){
    return temps_ms;
}